#ifndef CFS_HOST__H
#define CFS_HOST__H 1

// Local Headers
#include "Service.h"
#include "ServiceTypes.h"
#include "System.h"
#include "ProcessDescriptor.h"

// Library Headers
#include <CF.h>

// Standard Headers
#include <string>


#ifndef _WIN32
#define __IMPEXP__
#else
#undef __IMPEXP__
#ifdef __BUILDING_CFS__
#define __IMPEXP__ __declspec(dllexport)
#else
#define __IMPEXP__ __declspec(dllimport)
#endif // __BUILDING_CFS__
#endif // _WIN32


// Pre-declare
namespace ports { class CPort; }
namespace portutils { class CPortNotification; }


namespace cfs
{
    class __IMPEXP__ CHost : public CService
    {
    private:
        static const utils::string constMulticastPortName;
        static const utils::string constHostPortName;
        static const utils::string constProcessPortName;
        static const utils::string constHostDirectName;
        static const utils::string constTempPortName;

        // pre-declare
        class CConnectionMap;
        typedef utils::CPtr<CConnectionMap> pconnectionmap;

        typedef utils::CPtr<CHostDescriptor> phostdescriptor;


    public:
        /// Constructor
        explicit CHost( const utils::string& script_file = "", const utils::arguments &args = utils::arguments() );

        /// Destructor
        virtual ~CHost();

    };

} // namespace
#endif /* CFS_HOST__H */
